Subject: DLSw Version 0.16 Chapter 3 (1 of 2)

From: "Alan K. Bartky, Manager of Technology" <[email-masked]>
Date: Thu, 22 Dec 94 10:25: 9 PST

----------
X-Sun-Data-Type: text
X-Sun-Data-Description: text
X-Sun-Data-Name: text
X-Sun-Content-Lines: 3
X-Sun-Content-Length: 66

This is overall part 2 of 12

This is part 1 of 2 for chapter 3

----------
X-Sun-Data-Type: default
X-Sun-Data-Description: default
X-Sun-Data-Name: dlsw3a.txt
X-Sun-Content-Lines: 373
X-Sun-Content-Length: 14483



RFC XXXX      DLSw: Switch-to-Switch Protocol  December 1994

3. Transport Connection

   Data Link Switches can be in used in pairs or by themselves.

   A Single DLSw internally switches one data link to another without using
   TCP (DLC(1) to DLC(2) in the figure below).  This RFC does not go into
   details on how to implement this feature and it is not a requirement to
   support this RFC.

   A paired DLSw multiplexes data links over a reliable transport using a
   Switch-to-Switch Protocol (SSP).

   +-------------------------------------------+Switch-to-Switch
   |              DLC Interfaces               | Protocol (SSP)
   |+-----------+   DLC Request  +-----------+ |
   ||   Data    |<---------------|           | |Send SSP Frame
   ||   Link    | DLC Indication |           | |-------------->
   || Control 1 |--------------->|           | |
   |+-----------+                | Data Link | |
   |+-----------+   DLC Request  |  Switch   | |
   ||   Data    |<-------------- |           | |Rec. SSP Frame
   ||   Link    | DLC Indication |           | |<-------------
   || Control 2 | -------------->|           | |
   |+-----------+                +-----------+ |
   |            Multi-Protocol Router          |
   +-------------------------------------------+

   Before Data Link Switching can occur between two routers, they must
   establish two TCP connections between them.  Each Data Link Switch will
   maintain a list of DLSw capable routers and their status
   (active/inactive).  After the TCP connection is established, SSP
   messages are exchanged to establish the capabilities of the two Data
   Link Switches.  Once the exchange is complete,  the DLSw will employ SSP
   control messages to establish end-to-end circuits over the transport
   connection.  Within the transport connection, DLSw SSP messages are
   exchanged.  The message formats and types for these SSP messages are
   documented in the following sections.

   The default parameters associated with the TCP connections between Data
   Link Switches are as follows:

   Socket Family     AF_INET        (Internet protocols)
   Socket Type       SOCK_STREAM    (stream socket)
   Read Port Number  2065
   Write Port Number 2067

   Two or more Data Link Switches may be attached to the same LAN,
   consisting of a number of token-ring segments interconnected by source-
   routing bridges.  In this case, a TCP connection is not defined between
   bridges attached to the same LAN.  This will allow using systems to
   select one of the possible Data Link Switches in a similar manner to the
   selection of a bridge path through a source- routed bridged network.

AIW DLSw Related Interest Group           DLSw version 0.16 [Page 8]

RFC XXXX      DLSw: Switch-to-Switch Protocol  December 1994

   The virtual ring segment in each Data Link Switch attached to a common
   LAN must be configured with the same ring number.  This will prevent LAN
   frames sent by one Data Link Switch from being propagated through the
   other Data Link Switches.

3.1. SSP Frame Formats

   The following diagrams show the two message header formats exchanged
   between Data Link Switches, Control and Information.  The Control
   message header is used for all messages except Information Frames
   (INFOFRAME) and Independent Flow Control Messages (IFCM), which are sent
   in Information header format.  The INFOFRAME, KEEPALIVE and IFCM message
   headers are 16 bytes long, and the control message header is 72 bytes
   long.  The fields in the first sixteen bytes of all message headers are
   the same.

AIW DLSw Related Interest Group           DLSw version 0.16 [Page 9]

RFC XXXX      DLSw: Switch-to-Switch Protocol  December 1994

    CONTROL MESSAGES (72 Bytes)
    (zero based offsets below shown in decimal (xx) )
   +-----------------------------+-----------------------------+
   | (00) Version Number         | (01) Header Length (= 72)   |
   +-----------------------------+-----------------------------+
   | (02) Message Length                                       |
   +-----------------------------+-----------------------------+
   | (04) Remote Data Link Correlator                          |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |
   +-----------------------------+-----------------------------+
   | (08) Remote DLC Port ID                                   |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |
   +-----------------------------+-----------------------------+
   | (12) Reserved Field                                       |
   +-----------------------------+-----------------------------+
   | (14) Message Type           | (15) Flow Control Byte      |
   +-----------------------------+-----------------------------+
   | (16) Protocol ID            | (17) Header Number          |
   +-----------------------------+-----------------------------+
   | (18) Reserved                                             |
   +-----------------------------+-----------------------------+
   | (20) Largest Frame Size     | (21) SSP Flags              |
   +-----------------------------+-----------------------------+
   | (22) Circuit Priority       | (23) Message Type (see note)|
   +-----------------------------+-----------------------------+
   | (24) Target MAC Address  (non-canonical format)           |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -|
   |                                                           |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |
   +-----------------------------+-----------------------------+
   | (30) Origin MAC Address  (non-canonical format)           |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -|
   |                                                           |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |            .                              .               |
   +-----------------------------+-----------------------------+
   | (36) Origin Link SAP        | (37) Target Link SAP        |
   +-----------------------------+-----------------------------+
   | (38) Frame Direction        | (39) Reserved               |
   +-----------------------------+-----------------------------+
   | (40) Reserved                                             |
   +-----------------------------+-----------------------------+
   | (42) DLC Header Length                                    |
   +-----------------------------+-----------------------------+
   | (44) Origin DLC Port ID                                   |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |
   +-----------------------------+-----------------------------+
   | (48) Origin Data Link Correlator                          |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |

AIW DLSw Related Interest Group           DLSw version 0.16 [Page 10]

RFC XXXX      DLSw: Switch-to-Switch Protocol  December 1994

   +-----------------------------+-----------------------------+
   | (52) Origin Transport ID                                  |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |
   +-----------------------------+-----------------------------+
   | (56) Target DLC Port ID                                   |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |
   +-----------------------------+-----------------------------+
   | (60) Target Data Link Correlator                          |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |
   +-----------------------------+-----------------------------+
   | (64) Target Transport ID                                  |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |
   +-----------------------------+-----------------------------+
   | (68) Reserved Field                                       |
   +-----------------------------+-----------------------------+
   | (70) Reserved Field                                       |
   +-----------------------------+-----------------------------+
            (Even Byte)                     (Odd Byte)

AIW DLSw Related Interest Group           DLSw version 0.16 [Page 11]

RFC XXXX      DLSw: Switch-to-Switch Protocol  December 1994

    INFORMATION MESSAGE (16 Bytes)
   +-----------------------------+-----------------------------+
   | (00) Version Number         | (01) Header Length (= 16)   |
   +-----------------------------+-----------------------------+
   | (02) Message Length                                       |
   +-----------------------------+-----------------------------+
   | (04) Remote Data Link Correlator                          |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |
   +-----------------------------+-----------------------------+
   | (08) Remote DLC Port ID                                   |
   +- - - - - - - - - - - - - - -+- - - - - - - - - - - - - - -+
   |                                                           |
   +-----------------------------+-----------------------------+
   | (12) Reserved Field                                       |
   +-----------------------------+-----------------------------+
   | (14) Message Type           | (15) Flow Control Byte      |
   +-----------------------------+-----------------------------+
            (Even Byte)                    (Odd Byte)

   The first sixteen bytes of control and information message headers
   contain identical fields.  A brief description of some of the fields in
   an SSP message are shown below (if not defined below, the fields and/or
   their values are described in subsequent sections).

   The Version Number field (offset 0) is set to 0x31 (ASCII '1'),
   indicating a decimal value of 49.  This is used to indicate DLSw version
   1.

   The Header Length field (offset 1) is 0x48 for control messages,
   indicating a decimal value of 72 bytes, and 0x10 for information and
   Independent Flow Control messages, indicating a decimal value of 16
   bytes.

   The Message Length field (offset 2) defines the number of bytes within
   the data field following the header.

   The Flow Control Byte field (offset 15)  is described in section 8.

   The Header Number field (offset 17) is 0x01, indicating a value of one.

   The Circuit Priority field (offset 22) is described in section 4.

   The Frame Direction field (offset 38) is set to 0x01 for frames sent
   from the origin DLSw to the target DLSw, and is set to 0x02 for frames
   sent from the target DLSw to the origin DLSw.

     Note:  The Remote Data Link Correlator and Remote DLC Port ID are set
     equal to the Target Data Link Correlator and Target DLC Port ID if the
     Frame Direction field is set to 0x01, and are set equal to the Origin
     Data Link Correlator and Origin DLC Port ID if the Direction Field is
     set to 0x02.

AIW DLSw Related Interest Group           DLSw version 0.16 [Page 12]

RFC XXXX      DLSw: Switch-to-Switch Protocol  December 1994

   The Protocol ID field is set to 0x42, indicating a decimal value of 66.

   The DLC Header Length is set to zero for SNA and is set to 0x23 for
   NetBIOS datagrams, indicating a length of 35 bytes.  This includes the
   Access Control (AC) field, the Frame Control (FC) field, Destination MAC
   Address (DA), the Source MAC Address (SA), the Routing Information (RI)
   field (padded to 18 bytes), the Destination link SAP (DSAP), the Source
   link SAP (SSAP), and the LLC control field (UI).

   NOTE:  The values for the Message Type field are defined in section 3.5.
   Note that this value is specified in two different fields (offset 14 and
   23 decimal) of the control message header.  Only the first field is to
   be used when parsing a received SSP message.  The second field is to be
   ignored by new implementations on reception.  The second field was left
   in for backwards compatibility with RFC 1434 implementations and this
   field may be used in future versions if needed.

   The SSP Flags field contains additional information related to the SSP
   message.  The flags are defined as follows (bit 7 being the most
   significant bit and bit 0 the least significant bit of the octet):

   Bit(s)
   76543210    Name    Meaning
   ---------   -----   -------
   x.......    SSPex   1 = explorer message (CANUREACH and ICANREACH)
   .xxxxxxx            not used

   Reserved fields are set to zero upon transmission and should be ignored
   upon receipt.

3.2. Address Parameters

   A data link is defined as a logical association between the two end
   stations using Data Link Switching.  It is identified by a Data Link ID
   (14 bytes) consisting of the pair of attachment addresses associated
   with each end system.  Each attachment address is represented by the
   concatenation of the MAC address (6 bytes) and the LLC address (1 byte).
   Each attachment address is classified as either "Target" in the context
   of the Destination MAC/SAP addresses of an explorer frame sent in the
   first frame used to establish a circuit, or "Origin" in the context of
   the Source MAC/SAP addresses.  All MAC addresses are expressed in non-
   canonical (Token-Ring) format.

AIW DLSw Related Interest Group           DLSw version 0.16 [Page 13]